{% include "/doc/_urls.md" %}
# ES2015

Using the `import` key word to load the [CommonJS] files from `lib/`.
```javascript
import {element, property, attribute} from 'ceb';
```

The [ES2015] source files are available from `src/`.

Using the `import` key word to load the [ES2015] files from `src/`:
```javascript
import {element, property, attribute} from 'ceb/src/ceb.js';
```

Using the `import` key word to load the [ES2015] files one by one from `src/`:
```javascript
import {element} from 'ceb/src/builder/element.js';
import {property} from 'ceb/src/builder/property.js';
import {attribute} from 'ceb/src/builder/attribute.js';
```

And at the end:
```javascript
element(
    property('foo'),
    attribute('bar')
).register('ceb-example');
```

[ES2015] files should be used with [webpack], [browserify] or any bundling tools.

The [examples][live] as well as a part of the dist files are built with [webpack] from the [ES2015] files.
