'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isFunction = isFunction;
exports.isUndefined = isUndefined;
exports.isNull = isNull;
exports.isString = isString;
exports.isArray = isArray;
// obviously close to underscorejs and lodash ;)

/**
 * Checks if value is a Function object.
 * @param [value] the value to check
 * @return {boolean} true if value is a function, else false.
 */
function isFunction(value) {
  return Object.prototype.toString.call(value) === '[object Function]';
}

/**
 * Checks if value is undefined.
 * @param [value] the value to check
 * @return {boolean} true if value is undefined, else false.
 */
function isUndefined(value) {
  return value === undefined;
}

/**
 * Checks if value is null.
 * @param [value] the value to check
 * @return {boolean} true if value is null, else false.
 */
function isNull(value) {
  return value === null;
}

/**
 * Checks if value is a string.
 * @param [value] the value to check
 * @return {boolean} true if value is a string, else false.
 */
function isString(value) {
  return Object.prototype.toString.call(value) === '[object String]';
}

/**
 * Checks if value is an array.
 * @param [value] the value to check
 * @return {boolean} true if value is an array, else false.
 */
function isArray(value) {
  return Object.prototype.toString.call(value) === '[object Array]';
}